
#include "Nextion.h"                  
#define MAX_RELAYS 24

int RelayPins[MAX_RELAYS]  = { 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 44, 40, 41, 42, 43, 45}; // Relay 0 is at pin 22, relay 1 is at pin 23 and so on.
int A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S, T, U, V, W, X, Y, Z;

   
                                        // startR-- es la variable que almacena el tiempo millis()
  long startR1 = 0;
  long startR2 = 0;
  long startR3 = 0;
  long startR4 = 0;
  long startR5 = 0;
  long startR6 = 0;
  long startR7 = 0;
  long startR8 = 0;
  long startR9 = 0;
  long startR10 = 0;
  long startR11 = 0;
  long startR12 = 0;
  long startR13 = 0;
  long startR14 = 0;
  long startR15 = 0;
  long startR16 = 0;
  long startR17 = 0;
  long startR18 = 0;
                                          
int appData; 
uint32_t dual_state;

NexDSButton bt0subir1salon = NexDSButton(0,1,"bt0subir1salon");
NexDSButton bt1subir2salon = NexDSButton(0,2,"bt1subir2salon");
NexDSButton bt2subir3salon = NexDSButton(0,3,"bt2subir3salon");
NexDSButton bt3subir4salon = NexDSButton(0,4,"bt3subir4salon");
NexDSButton bt4subirPhab = NexDSButton(0,5,"bt4subirPhab");
NexDSButton bt5subirVhab = NexDSButton(0,6,"bt5subirVhab");
NexDSButton bt6subirGrande = NexDSButton(0,7,"bt6subirGrande");
NexDSButton bt7subir2Atico = NexDSButton(0,8,"bt7subir2Atico");
NexDSButton bt8Subir1Atico = NexDSButton(0,9,"bt8Subir1Atico");
NexDSButton bt9bajar1sal = NexDSButton(0,10,"bt9bajar1sal");
NexDSButton bt10bajar2salo = NexDSButton(0,11,"bt10bajar2salo");
NexDSButton bt11bajar3salo = NexDSButton(0,12,"bt11bajar3salo");
NexDSButton bt12bajar4salo = NexDSButton(0,13,"bt12bajar4salo");
NexDSButton bt13bajarPhab = NexDSButton(0,14,"bt13bajarPhab");
NexDSButton bt14bajarVhab = NexDSButton(0,15,"bt14bajarVhab");
NexDSButton bt15BajarGrand = NexDSButton(0,16,"bt15BajarGrand");
NexDSButton bt16Bajar2Atic = NexDSButton(0,17,"bt16Bajar2Atic");
NexDSButton bt17Bajar1Atic = NexDSButton(0,18,"bt17Bajar1Atic");
NexDSButton bt0Parar = NexDSButton(0,19,"bt0Parar");
NexNumber ntemperatura = NexNumber(0,21,"ntemperatura");
 
NexTouch *nex_listen_list[] = 
{                                                                     
    &bt0subir1salon,
    &bt1subir2salon,
    &bt2subir3salon,
    &bt3subir4salon,
    &bt4subirPhab,
    &bt5subirVhab,
    &bt6subirGrande,
    &bt7subir2Atico,
    &bt8Subir1Atico,
    &bt9bajar1sal,
    &bt10bajar2salo,
    &bt11bajar3salo,
    &bt12bajar4salo,
    &bt13bajarPhab,
    &bt14bajarVhab, 
    &bt15BajarGrand,
    &bt16Bajar2Atic,
    &bt17Bajar1Atic,
    &bt0Parar,
    NULL
};
  
////////==================================================================
  void setup(){

  Serial.begin(9600);                               // Set serial monitor baud rate

                                            // Initialize Output PORTS
  for (int i = 0; i < MAX_RELAYS; i++) {
    pinMode(RelayPins[i], OUTPUT);
  }
                                            // poner reles a nivel bajo
  for (int i = 0; i < MAX_RELAYS; i++) {
    digitalWrite(RelayPins[i], HIGH);
  }
    
    nexInit(); 
   Serial.println("Setup completed.");
    }
 
//==================================================================

void loop(){
  
       Serial.println(">>>>>>>>>>>>>>>>>>>>>>>>>>1");
  
     appData = 0 ;

       Serial.println(">>>>>>>>>>>>>>>>>>>>>>>>>>2");
     
      nexLoop(nex_listen_list); // Lee la pantalla Nextion

    bt0subir1salon.getValue(&dual_state);
    if ((dual_state) && (appData==0)) {appData = 65 ;} 

    bt1subir2salon.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 66 ;}

    bt2subir3salon.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 67 ;}

    bt3subir4salon.getValue(&dual_state);
   if ((dual_state) && (appData==0)) { appData = 68 ;}

    bt4subirPhab.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 69 ;}

    bt5subirVhab.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 70 ;}

    bt6subirGrande.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 81 ;}

    bt7subir2Atico.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 71 ;}

    bt8Subir1Atico.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 72 ;}

    bt9bajar1sal.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 80 ;}

    bt10bajar2salo.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 79 ;}

    bt11bajar3salo.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 78 ;}

    bt12bajar4salo.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 77 ;}

    bt13bajarPhab.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 76 ;}

    bt14bajarVhab.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 75 ;}
 
    bt15BajarGrand.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 82 ;}

    bt16Bajar2Atic.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 74 ;}

    bt17Bajar1Atic.getValue(&dual_state);
    if ((dual_state) && (appData==0)) { appData = 73 ;}


                                                                 //ES PARA PARAR TODO
    bt0Parar.getValue(&dual_state);
    if(dual_state) {bt0Parar.setValue(0); appData = 99 ;}     
   
   if (appData==99) {A=0; B=0; C=0; D=0; E=0; F=0; G=0; H=0; I=0; J=0; K=0; L=0; M=0; N=0; O=0; P=0 ; Q=0; R=0; appData = 0;}  

  
                                                            
                                                           //ES PARA PARAR CUALQUIER EVENTO
  if (appData==A){ digitalWrite(RelayPins[0], HIGH); appData = 0; A = 0;}
  if (appData==B){ digitalWrite(RelayPins[1], HIGH); appData = 0; B = 0;}
  if (appData==C){ digitalWrite(RelayPins[2], HIGH); appData = 0; C = 0;}
  if (appData==D){ digitalWrite(RelayPins[3], HIGH); appData = 0; D = 0;}
  if (appData==E){ digitalWrite(RelayPins[4], HIGH); appData = 0; E = 0;}
  if (appData==F){ digitalWrite(RelayPins[5], HIGH); appData = 0; F = 0;}
  if (appData==G){ digitalWrite(RelayPins[6], HIGH); appData = 0; G = 0;}
  if (appData==H){ digitalWrite(RelayPins[7], HIGH); appData = 0; H = 0;}
  if (appData==I){ digitalWrite(RelayPins[8], HIGH); appData = 0; I = 0;}
  if (appData==J){ digitalWrite(RelayPins[9], HIGH); appData = 0; J = 0;}
  if (appData==K){ digitalWrite(RelayPins[10], HIGH); appData = 0; K = 0;}
  if (appData==L){ digitalWrite(RelayPins[11], HIGH); appData = 0; L = 0;}
  if (appData==M){ digitalWrite(RelayPins[12], HIGH); appData = 0; M = 0;}
  if (appData==N){ digitalWrite(RelayPins[13], HIGH); appData = 0; N = 0;}
  if (appData==O){ digitalWrite(RelayPins[14], HIGH); appData = 0; O = 0;}
  if (appData==P){ digitalWrite(RelayPins[15], HIGH); appData = 0; P = 0;}
  if (appData==Q){ digitalWrite(RelayPins[16], HIGH); appData = 0; Q = 0;}
  if (appData==R){ digitalWrite(RelayPins[17], HIGH); appData = 0; R = 0;}
  
   
                                                 //ES PARA EVITAR QUE SE PUEDAN ACTIVAR "SUBIR" Y "BAJAR" AL MISMO TIEMPO
  if ((appData==65) && (P == 0)) {A = 65; startR1 = millis ();}   // subir persiana 1 (ventana peq. salon)
  if ((appData==66) && (O == 0)) {B = 66; startR2 = millis ();}   // subir persiana 2 (ventana grande salon)
  if ((appData==67) && (N == 0)) {C = 67; startR3 = millis ();}   // subir persiana 3 (puerta salon)
  if ((appData==68) && (M == 0)) {D = 68; startR4 = millis ();}   // subir persiana 4 (puerta doble salon)
  if ((appData==69) && (L == 0)) {E = 69; startR5 = millis ();}   // subir persiana 5 (puerta hab.)
  if ((appData==70) && (K == 0)) {F = 70; startR6 = millis ();}   // subir persiana 6 (ventana hab.)
  if ((appData==71) && (J == 0)) {G = 71; startR7 = millis ();}   // subir persiana 8 (atico)
  if ((appData==72) && (I == 0)) {H = 72; startR8 = millis ();}   // subir persiana 9 (atico)
  if ((appData==73) && (H == 0)) {I = 73; startR9 = millis ();}   // bajar persiana 9 (atico)
  if ((appData==74) && (G == 0)) {J = 74; startR10 = millis ();}  // bajar persiana 8 (atico) 
  if ((appData==75) && (B == 0)) {K = 75; startR11 = millis ();}  // bajar persiana 6 (ventana hab.)
  if ((appData==76) && (A == 0)) {L = 76; startR12 = millis ();}  // bajar persiana 5 (puerta hab.)
  if ((appData==77) && (D == 0)) {M = 77; startR13 = millis ();}  // bajar persiana 4 (puerta doble salon)
  if ((appData==78) && (C == 0)) {N = 78; startR14 = millis ();}  // bajar persiana 3 (puerta salon)
  if ((appData==79) && (B == 0)) {O = 79; startR15 = millis ();}  // bajar persiana 2 (ventana grande salon
  if ((appData==80) && (A == 0)) {P = 80; startR16 = millis ();}  // bajar persiana 1 (ventana peq. salon
  if ((appData==81) && (R == 0)) {Q = 81; startR17 = millis ();}  // subir persiana 7 (grande atico)
  if ((appData==82) && (Q == 0)) {R = 82; startR18 = millis ();}  // bajar persiana 7 (grande atico)
  
  if (A || B || C || D || E || F || G || H || I || J || K || L || M || N || O || P || Q || R >2) {Serial.println("ENCEDIDO DESCONECTAFASE"); digitalWrite(RelayPins[18], LOW);}
  if ((A==0) && (B==0) && (C==0) && (D==0) && (E==0) && (F==0) && (G==0) && (H==0) && (I==0) && (J==0) && (K==0) && (L==0) && (M==0) && (N==0) && (O==0) && (P==0) && (Q==0) && (R==0)) {Serial.println("APAGADO DESCONECTAFASE"); digitalWrite(RelayPins[18], HIGH);}


     if (A==65) {bt0subir1salon.setValue(0); bt0subir1salon.Set_state0_image_pic0(13);} else { bt0subir1salon.Set_state0_image_pic0(1);}
     if (B==66) {bt1subir2salon.setValue(0); bt1subir2salon.Set_state0_image_pic0(14);} else { bt1subir2salon.Set_state0_image_pic0(3);}
     if (C==67) {bt2subir3salon.setValue(0); bt2subir3salon.Set_state0_image_pic0(15);} else { bt2subir3salon.Set_state0_image_pic0(4);}
     if (D==68) {bt3subir4salon.setValue(0); bt3subir4salon.Set_state0_image_pic0(16);} else { bt3subir4salon.Set_state0_image_pic0(5);}
     if (E==69) {bt4subirPhab.setValue(0); bt4subirPhab.Set_state0_image_pic0(22);} else { bt4subirPhab.Set_state0_image_pic0(7);}
     if (F==70) {bt5subirVhab.setValue(0); bt5subirVhab.Set_state0_image_pic0(21);} else { bt5subirVhab.Set_state0_image_pic0(8);}
     if (Q==81) {bt6subirGrande.setValue(0); bt6subirGrande.Set_state0_image_pic0(18);} else { bt6subirGrande.Set_state0_image_pic0(12);}
     if (G==71) {bt7subir2Atico.setValue(0); bt7subir2Atico.Set_state0_image_pic0(14);} else { bt7subir2Atico.Set_state0_image_pic0(3);}
     if (H==72) {bt8Subir1Atico.setValue(0); bt8Subir1Atico.Set_state0_image_pic0(13);} else { bt8Subir1Atico.Set_state0_image_pic0(1);}
     if (P==80) {bt9bajar1sal.setValue(0); bt9bajar1sal.Set_state0_image_pic0(20);} else { bt9bajar1sal.Set_state0_image_pic0(2);}
     if (O==79) {bt10bajar2salo.setValue(0); bt10bajar2salo.Set_state0_image_pic0(20);} else { bt10bajar2salo.Set_state0_image_pic0(2);}
     if (N==78) {bt11bajar3salo.setValue(0); bt11bajar3salo.Set_state0_image_pic0(20);} else { bt11bajar3salo.Set_state0_image_pic0(2);}
     if (M==77) {bt12bajar4salo.setValue(0); bt12bajar4salo.Set_state0_image_pic0(20);} else { bt12bajar4salo.Set_state0_image_pic0(2);}
     if (L==76) {bt13bajarPhab.setValue(0); bt13bajarPhab.Set_state0_image_pic0(19);} else { bt13bajarPhab.Set_state0_image_pic0(6);}
     if (K==75) {bt14bajarVhab.setValue(0); bt14bajarVhab.Set_state0_image_pic0(19);} else { bt14bajarVhab.Set_state0_image_pic0(6);}
     if (R==82) {bt15BajarGrand.setValue(0); bt15BajarGrand.Set_state0_image_pic0(17);} else { bt15BajarGrand.Set_state0_image_pic0(0);}
     if (J==74) {bt16Bajar2Atic.setValue(0); bt16Bajar2Atic.Set_state0_image_pic0(17);} else { bt16Bajar2Atic.Set_state0_image_pic0(0);}   
     if (I==73) {bt17Bajar1Atic.setValue(0); bt17Bajar1Atic.Set_state0_image_pic0(17);} else { bt17Bajar1Atic.Set_state0_image_pic0(0);}
   
  
  if (A==65) { 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR1 >= 50) {
      digitalWrite(RelayPins[0], LOW);
    }
    if (tiempoActual - startR1 >= 30000) {
      digitalWrite(RelayPins[0], HIGH);
      A = 0;
    }
  }

  if (B==66){ 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR2 >= 50) {
      digitalWrite(RelayPins[1], LOW);
    }
      if (tiempoActual - startR2 >= 30000) {
        digitalWrite(RelayPins[1], HIGH);
          B = 0;
     }
  }
  
   if (C==67) { 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR3 >= 50) {
      digitalWrite(RelayPins[2], LOW);
    }
    if (tiempoActual - startR3 >= 30000) {
      digitalWrite(RelayPins[2], HIGH);
      C = 0;
    }
  }

  if (D==68){ 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR4 >= 50) {
      digitalWrite(RelayPins[3], LOW);
    }
      if (tiempoActual - startR4 >= 30000) {
        digitalWrite(RelayPins[3], HIGH);
          D = 0;
     }
  }
  
  if (E==69) { 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR5 >= 50) {
      digitalWrite(RelayPins[4], LOW);
    }
    if (tiempoActual - startR5 >= 30000) {
      digitalWrite(RelayPins[4], HIGH);
      E = 0;
    }
  }

  if (F==70){ 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR6 >= 50) {
      digitalWrite(RelayPins[5], LOW);
    }
      if (tiempoActual - startR6 >= 30000) {
        digitalWrite(RelayPins[5], HIGH);
          F = 0;
     }
  }
  
   if (G==71) { 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR7 >= 50) {
      digitalWrite(RelayPins[6], LOW);
    }
    if (tiempoActual - startR7 >= 30000) {
      digitalWrite(RelayPins[6], HIGH);
      G = 0;
    }
  }

  if (H==72){ 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR8 >= 50) {
      digitalWrite(RelayPins[7], LOW);
    }
      if (tiempoActual - startR8 >= 30000) {
        digitalWrite(RelayPins[7], HIGH);
          H = 0;
     }
  }

    if (I==73) { 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR9 >= 50) {
      digitalWrite(RelayPins[8], LOW);
    }
    if (tiempoActual - startR9 >= 30000) {
      digitalWrite(RelayPins[8], HIGH);
      I = 0;
    }
  }

  if (J==74){ 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR10 >= 50) {
      digitalWrite(RelayPins[9], LOW);
    }
      if (tiempoActual - startR10 >= 30000) {
        digitalWrite(RelayPins[9], HIGH);
          J = 0;
     }
  }
  
   if (K==75) { 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR11 >= 50) {
      digitalWrite(RelayPins[10], LOW);
    }
    if (tiempoActual - startR11 >= 30000) {
      digitalWrite(RelayPins[10], HIGH);
      K = 0;
    }
  }

  if (L==76){ 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR12 >= 50) {
      digitalWrite(RelayPins[11], LOW);
    }
      if (tiempoActual - startR12 >= 30000) {
        digitalWrite(RelayPins[11], HIGH);
          L = 0;
     }
  }
  
    if (M==77) { 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR13 >= 50) {
      digitalWrite(RelayPins[12], LOW);
    }
    if (tiempoActual - startR13 >= 30000) {
      digitalWrite(RelayPins[12], HIGH);
      M = 0;
    }
  }

  if (N==78){ 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR14 >= 50) {
      digitalWrite(RelayPins[13], LOW);
    }
      if (tiempoActual - startR14 >= 30000) {
        digitalWrite(RelayPins[13], HIGH);
          N = 0;
     }
  }
  
   if (O==79) { 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR15 >= 50) {
      digitalWrite(RelayPins[14], LOW);
    }
    if (tiempoActual - startR15 >= 30000) {
      digitalWrite(RelayPins[14], HIGH);
      O = 0;
    }
  }

  if (P==80){ 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR16 >= 50) {
      digitalWrite(RelayPins[15], LOW);
    }
      if (tiempoActual - startR16 >= 30000) {
        digitalWrite(RelayPins[15], HIGH);
          P = 0;
     }
  }
  
  if (Q==81){ 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR17 >= 50) {
      digitalWrite(RelayPins[16], LOW);
    }
      if (tiempoActual - startR17 >= 30000) {
        digitalWrite(RelayPins[16], HIGH);
          Q = 0;
     }
  }
  
   if (R==82) { 
    unsigned long tiempoActual = millis ();
    if (tiempoActual - startR18 >= 50) {
      digitalWrite(RelayPins[17], LOW);
    }
    if (tiempoActual - startR18 >= 30000) {
      digitalWrite(RelayPins[17], HIGH);
      R = 0;
    }
  }
  }
    
  
